<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_201) on Tue Jun 11 21:47:07 AEST 2019 -->
<title>EventBus (worldedit-core 7.0.0 API)</title>
<meta name="date" content="2019-06-11">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="EventBus (worldedit-core 7.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/util/eventbus/EventBus.html" target="_top">Frames</a></li>
<li><a href="EventBus.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.sk89q.worldedit.util.eventbus</div>
<h2 title="Class EventBus" class="title">Class EventBus</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>com.sk89q.worldedit.util.eventbus.EventBus</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public final class <span class="typeNameLabel">EventBus</span>
extends java.lang.Object</pre>
<div class="block">Dispatches events to listeners, and provides ways for listeners to register
 themselves.

 <p>This class is based on Guava's <a href="../../../../../com/sk89q/worldedit/util/eventbus/EventBus.html" title="class in com.sk89q.worldedit.util.eventbus"><code>EventBus</code></a> but priority is supported
 and events are dispatched at the time of call, rather than being queued up.
 This does allow dispatching during an in-progress dispatch.</p></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventBus.html#EventBus--">EventBus</a></span>()</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventBus.html#post-java.lang.Object-">post</a></span>(java.lang.Object&nbsp;event)</code>
<div class="block">Posts an event to all registered handlers.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventBus.html#register-java.lang.Object-">register</a></span>(java.lang.Object&nbsp;object)</code>
<div class="block">Registers all handler methods on <code>object</code> to receive events.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventBus.html#subscribe-java.lang.Class-com.sk89q.worldedit.util.eventbus.EventHandler-">subscribe</a></span>(java.lang.Class&lt;?&gt;&nbsp;clazz,
         <a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus">EventHandler</a>&nbsp;handler)</code>
<div class="block">Registers the given handler for the given class to receive events.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventBus.html#subscribeAll-com.google.common.collect.Multimap-">subscribeAll</a></span>(com.google.common.collect.Multimap&lt;java.lang.Class&lt;?&gt;,<a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus">EventHandler</a>&gt;&nbsp;handlers)</code>
<div class="block">Registers the given handler for the given class to receive events.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventBus.html#unregister-java.lang.Object-">unregister</a></span>(java.lang.Object&nbsp;object)</code>
<div class="block">Unregisters all handler methods on a registered <code>object</code>.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventBus.html#unsubscribe-java.lang.Class-com.sk89q.worldedit.util.eventbus.EventHandler-">unsubscribe</a></span>(java.lang.Class&lt;?&gt;&nbsp;clazz,
           <a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus">EventHandler</a>&nbsp;handler)</code>
<div class="block">Unregisters the given handler for the given class.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventBus.html#unsubscribeAll-com.google.common.collect.Multimap-">unsubscribeAll</a></span>(com.google.common.collect.Multimap&lt;java.lang.Class&lt;?&gt;,<a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus">EventHandler</a>&gt;&nbsp;handlers)</code>
<div class="block">Unregisters the given handlers.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="EventBus--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>EventBus</h4>
<pre>public&nbsp;EventBus()</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="subscribe-java.lang.Class-com.sk89q.worldedit.util.eventbus.EventHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>subscribe</h4>
<pre>public&nbsp;void&nbsp;subscribe(java.lang.Class&lt;?&gt;&nbsp;clazz,
                      <a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus">EventHandler</a>&nbsp;handler)</pre>
<div class="block">Registers the given handler for the given class to receive events.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>clazz</code> - the event class to register</dd>
<dd><code>handler</code> - the handler to register</dd>
</dl>
</li>
</ul>
<a name="subscribeAll-com.google.common.collect.Multimap-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>subscribeAll</h4>
<pre>public&nbsp;void&nbsp;subscribeAll(com.google.common.collect.Multimap&lt;java.lang.Class&lt;?&gt;,<a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus">EventHandler</a>&gt;&nbsp;handlers)</pre>
<div class="block">Registers the given handler for the given class to receive events.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>handlers</code> - a map of handlers</dd>
</dl>
</li>
</ul>
<a name="unsubscribe-java.lang.Class-com.sk89q.worldedit.util.eventbus.EventHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>unsubscribe</h4>
<pre>public&nbsp;void&nbsp;unsubscribe(java.lang.Class&lt;?&gt;&nbsp;clazz,
                        <a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus">EventHandler</a>&nbsp;handler)</pre>
<div class="block">Unregisters the given handler for the given class.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>clazz</code> - the class</dd>
<dd><code>handler</code> - the handler</dd>
</dl>
</li>
</ul>
<a name="unsubscribeAll-com.google.common.collect.Multimap-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>unsubscribeAll</h4>
<pre>public&nbsp;void&nbsp;unsubscribeAll(com.google.common.collect.Multimap&lt;java.lang.Class&lt;?&gt;,<a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus">EventHandler</a>&gt;&nbsp;handlers)</pre>
<div class="block">Unregisters the given handlers.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>handlers</code> - a map of handlers</dd>
</dl>
</li>
</ul>
<a name="register-java.lang.Object-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>register</h4>
<pre>public&nbsp;void&nbsp;register(java.lang.Object&nbsp;object)</pre>
<div class="block">Registers all handler methods on <code>object</code> to receive events.
 Handler methods are selected and classified using this EventBus's
 <code>SubscriberFindingStrategy</code>; the default strategy is the
 <code>AnnotatedSubscriberFinder</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>object</code> - object whose handler methods should be registered.</dd>
</dl>
</li>
</ul>
<a name="unregister-java.lang.Object-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>unregister</h4>
<pre>public&nbsp;void&nbsp;unregister(java.lang.Object&nbsp;object)</pre>
<div class="block">Unregisters all handler methods on a registered <code>object</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>object</code> - object whose handler methods should be unregistered.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.IllegalArgumentException</code> - if the object was not previously registered.</dd>
</dl>
</li>
</ul>
<a name="post-java.lang.Object-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>post</h4>
<pre>public&nbsp;void&nbsp;post(java.lang.Object&nbsp;event)</pre>
<div class="block">Posts an event to all registered handlers.  This method will return
 successfully after the event has been posted to all handlers, and
 regardless of any exceptions thrown by handlers.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>event</code> - event to post.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../com/sk89q/worldedit/util/eventbus/EventHandler.html" title="class in com.sk89q.worldedit.util.eventbus"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/util/eventbus/EventBus.html" target="_top">Frames</a></li>
<li><a href="EventBus.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
